unit Mrdemo1;

{demo form to demonstrate the use of the TirisMR Component}

interface

uses WinTypes,
     WinProcs,
     Classes,
     Graphics,
     Forms,
     Controls,
     Menus,
     Dialogs,
     StdCtrls,
     Buttons,
     ExtCtrls,
     TIRISMR,
     Beeper,
     Messages,
     SysUtils;
type
  TForm1 = class(TForm)
    Button1: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Shape1: TShape;
    Label1: TLabel;
    Button2: TButton;
    Shape2: TShape;
    Label2: TLabel;
    Label3: TLabel;
    RadioGroup1: TRadioGroup;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Panel1: TPanel;
    FireBtn: TButton;
    TirisMR1: TTirisMR;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure TirisMR1CTSChanged(Sender: TObject; State: Boolean);
    procedure Button2Click(Sender: TObject);
    procedure TirisMR1DSRChanged(Sender: TObject; State: Boolean);
    procedure RadioGroup1Click(Sender: TObject);
    procedure TirisMR1RX(Sender: TObject; Data:TMRData);
    procedure FireBtnClick(Sender: TObject);
    procedure TirisMR1BeforeTX(Sender: TObject; var Datagram: OpenString);
    procedure TirisMR1Show(Sender: TObject; Data: TMRData);
    procedure TirisMR1TrackLost(Sender: TObject;
      OtherTransponder: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Type CRCTYPE = string[5];



var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  If TirisMR1.MRStart
   then
     begin
      CheckBox1.Enabled:=True;
      CheckBox2.Enabled:=True;
      Button2.Enabled:=True;
      Button1.enabled:=False;
      RadioGroup1.ItemIndex:=Ord(TirisMr1.Mode);
     end
    else ShowMessage(TirisMR1.GetError);
  
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  If TirisMR1.MRstart
    then
      begin
       CheckBox1.Enabled:=True;
       CheckBox2.Enabled:=True;
       Button2.Enabled:=True;
       Button1.enabled:=False;
      end
    else ShowMessage(TirisMR1.GetError);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  TirisMR1.RTS:=CheckBox1.Checked;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  TirisMR1.DTR:=CheckBox2.Checked;
end;

procedure TForm1.TirisMR1CTSChanged(Sender: TObject; State: Boolean);
begin
  If State then Shape1.Brush.Color:=clRed
           else Shape1.Brush.Color:=clGreen;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  TirisMR1.MRStop;
  CheckBox1.Enabled:=False;
  CheckBox2.Enabled:=False;
  Button2.Enabled:=False;
  Button1.enabled:=True;
end;

procedure TForm1.TirisMR1DSRChanged(Sender: TObject; State: Boolean);
begin
  If State then Shape2.Brush.Color:=clRed
           else Shape2.Brush.Color:=clGreen;

end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  Case RadioGroup1.ItemIndex of
  0:TirisMR1.Mode:=cmNone;
  1:TirisMR1.Mode:=cmShow;
  2:TirisMR1.Mode:=cmTrack;
  3:TirisMR1.Mode:=cmProgram;
  4:TirisMR1.Mode:=cmSingle;
  5:TirisMR1.Mode:=cmLine;
  6:TirisMR1.Mode:=cmNormal;
  7:TirisMR1.Mode:=cmVersion;
  end;
end;


procedure TForm1.TirisMR1RX(Sender: TObject; data: TMRData);
begin
  Label6.Caption:=String2Hex(data.RawData);
  With Data do
    begin
    if Version
      then Panel1.caption:='MicroReader Firmware Version: '+data

      else
    Case Transpondertype of
      ttReadOnly  : Panel1.caption:='R/O: '+data;
      ttReadWrite : Panel1.caption:='R/W: '+data;
      ttMPT       : Panel1.caption:='MPT/SAMPT: '+data;
      ttOther     : Panel1.caption:='UnKnown or NoRead'{+data};
    end;
    end;

end;


procedure TForm1.FireBtnClick(Sender: TObject);
begin
  TirisMR1.SendDatagram;
end;

procedure TForm1.TirisMR1BeforeTX(Sender: TObject;
  var Datagram: OpenString);
begin
  Label3.Caption:=String2Hex(Datagram);
  Label6.Caption:='';
end;

procedure TForm1.TirisMR1Show(Sender: TObject; Data: TMRData);
begin
  With Data do
    Case Transpondertype of
      ttReadOnly  : Panel1.caption:='R/O: '+data;
      ttReadWrite : Panel1.caption:='R/W: '+data;
      ttMPT       : Panel1.caption:='MPT/SAMPT: '+data;
      ttOther     : Panel1.caption:='UnKnown or NoRead'{+data};
    end;
  RadioGroup1.ItemIndex:=ord(cmTrack);
end;

procedure TForm1.TirisMR1TrackLost(Sender: TObject;
  OtherTransponder: Boolean);
begin
  If otherTransponder
    then ShowMessage('Other transponder detected')
    else ShowMessage('Time out') ;
  RadioGroup1.ItemIndex:=ord(cmShow);
end;

end.

